//##########################################################
//  OLSetKey.inc

//  Include file to implement ensuring that an element in an
//  ordered array is in the correct position.  Note that
//  moving "backwards" is moving towards the head of the list
//  (the end with the highest key values).

//  The following must be setup similar to:
//    #define  prev_OLElm prev_emp
//    #define  next_OLElm next_emp
//    #define  OLKey     imp
//    #define  OLHead    (schd->emp)
//    #define  OLElmTyp  employee

    int move_bwd = prev_OLElm && OLKey > prev_OLElm->OLKey;
    int move_fwd = next_OLElm && OLKey < next_OLElm->OLKey;

    if (move_bwd || move_fwd) {
                                         // Disconnect.
      if (prev_OLElm) {
        prev_OLElm->next_OLElm = next_OLElm;
      } else {
        OLHead = next_OLElm;
      }
      if (next_OLElm) {
        next_OLElm->prev_OLElm = prev_OLElm;
      }
                                         // Reconnect.
      OLElmTyp *e;

      if (move_bwd) {
        e = prev_OLElm;
        while (e && OLKey > e->OLKey) e = e->prev_OLElm;
      } else {   // move_fwd.
        e = next_OLElm;
        while (e && e->next_OLElm && OLKey < (e->next_OLElm)->OLKey) {
          e = e->next_OLElm;
        }
      }

      if (e) {    // Insert after e.
        prev_OLElm = e;
        next_OLElm = e->next_OLElm;
        if (e->next_OLElm)
                    (e->next_OLElm)->prev_OLElm = this;
        e->next_OLElm = this;
      } else {    // Insert at top of list.
        prev_OLElm = null;
        next_OLElm = OLHead;
        if (OLHead) (OLHead)->prev_OLElm = this;
        OLHead = this;
      }

    }

//##########################################################
