//  Brian Marshall      bmarshal@agt.net
//......................................

//  WorkForce Input File.

#include "workforc.h"

//----------------------------------------------------------
//  Construct a wif for the specified file.

wif::wif (char* filnam)
{

  ifp = fopen (filnam, "r");

  if (!ifp) {
    wlog3 ("\nCould not find file ", filnam, ".  ABORT.\n");
    wfexit(1);
  }

}

//----------------------------------------------------------
//  Construct a wif for the specified file.
//  Print the passed message on file open failure.

wif::wif (char* filnam, char* msg)
{

  ifp = fopen (filnam, "r");

  if (!ifp) {
    wlog (msg);
    wfexit(1);
  }

}

//----------------------------------------------------------
//  Destructor.

wif::~wif (void)
{
  fclose(ifp);
}

//----------------------------------------------------------
//  Close the file.

void  wif::close (void)
{
  fclose(ifp);
}

//----------------------------------------------------------
//  Get the next data record (ie. non-all-white record that does not
//  begin with an exclamation mark) and put in rec.
//  Return True on success, False on end-of-file.

int wif::get (void)
{

  while (True) {
    rec[0] = '\0';
    if (feof(ifp)) return False;
    fgets (rec, 100, ifp);
    if (ferror(ifp)) {
      wlog3 ("Error reading file ", fnam, ".  ABORT.\n");
      wfexit(1);
    }
    if (rec[0] == '!') continue;
    if (all_white(rec)) continue;
    break;                          // Only need this next record.
  }

  return True;

}

//----------------------------------------------------------
